// VERSION ALEJANDRO 13/03/2018
// ENLEVER LES ACCENTS 
// PROBLEMES DE MEMOIRE OK AVEC CHAR ARRAY  
  
  #include <LiquidCrystal.h>
  #include <String.h>
#define TAILLEECRAN 20 // longueur de l'ecran

LiquidCrystal lcd(6, 7, 5, 4, 3, 2);    
//CONNEXION EN 4-BIT DU LCD PIN  (RS,E,DB4,DB5,DB6,DB7)

int BoutonRouge = LOW;
int BoutonVert = LOW;
int BoutonBleu = LOW;
int BoutonGris = LOW;

// MENU PRINCIPAL
const char *menu_principal[2] = {
  "Affirmation",
  "Question"
};

// AFFIRMATIONS
int nbA = 38; //nb d'affirmation METTRE MANUELLEMENT
const char *menu_a[38] = {
  "Oui",
  "Non",
  "Je serai absent demain",
  "Je serai absent lundi",
  "Je serai absent mardi",
  "Je serai absent mercredi",
  "Je serai absent jeudi",
  "Je serai absent vendredi",
  "Je dois aller chez le kine", // ACCENT
  "Je vais bien",
  "Je ne vais pas tres bien", // ACCENT
  "J'ai soif",
  "J'ai faim",
  "Non merci",
  "Panne d'assensseur",
  "Je veux une paille",
  "Je veux un tapis pour manger",
  "Je suis avec...",
  "Je fais",
  "Tu peux m'aider",
  "Je peux t'aider",
  "Je viens",
  "Je ne viens pas",
  "J'ai mal",
  "Je suis malade",
  "Sort !!!",
  "Tu m'enerve",
  "Je veux jouer au carte",
  "Jouons au carte",
  "Je veux jouer au mot melee ou croise",
  "J'aime le Maroc",
  "Je suis marocain",
  "Je suis Tonton",
  "Je veux voir mon neveu",  
  "Je dois regarder plus belle la vie !!!",
  "Hier, j'ai mange une pizza tomate, basilic et fromage",  
  "Je veux un cafe", 
  "Deja, maman ne parle pas avant de boire son cafe",
};

// QUESTIONS
int nbQ = 21; //nb de Questions
const char *menu_q[21] = {
  "Pourquoi ?",
  "Comment ?",
  "Combien ?",
  "Qui ?",
  "A qui ?",
  "A quoi ?",
  "Peut-tu me passer un tapis antiderapant ?",
  "Peut-tu m'enlever le tapis antiderapant ?",
  "Quelle jour sera notre reunion du mois avec tous le monde ?", 
  "Quelle sera la destination du prochain transfer ?",
  "Puis-je voir mon neveu ?",
  "Puis-je regarder plus belle la vie ?",
  "Quand vais-je avoir mon fautieul electrique ?",
  "Quand vais-je avoir mon propre fautieul electrique ?",
  "Quand vais-je avoir mon nouveau fautieul electrique ?",
  "Quand vais-je avoir mon nouveau fautieul manuel ?",
  "Quand vais-je avoir mon fautieul manuel ?",
  "Quand vais-je avoir mon propre fautieul manuel ?",
  "Peux-tu me faire un cafe ?",
  "On mange quoi ?",
  "On mange quoi ce soir ?"
};

int validee = 0;
int retour = 0;
int choix_menu = 0;
int choix_phrase = 0;
int position_menu = 0;

void setup() {
  lcd.begin(20, 4);
  Serial.begin(9600);

  pinMode (10, INPUT);
  pinMode (11, INPUT);
  pinMode (12, INPUT);
  pinMode (13, INPUT);

}

void loop() {

  // AFFICHER MENU PRINCIPAL
  lcd.clear();
  lcd.setCursor(2, 0);
  lcd.print(menu_principal[0]);
  lcd.setCursor(2, 2);
  lcd.print(menu_principal[1]);
  delay(2000);
  lcd.setCursor(0, 0);
  lcd.blink();

  // CHOISIR MENU PRINCIPAL
  validee = 0;
  choix_menu=0;
  while (validee == 0) {

    // LIRE
    lire_boutons();

    // CHOISIR OPTION 1 (AFFIRMATION)
    if (BoutonRouge == HIGH) {
      lcd.setCursor(0, 0);
      choix_menu = 0;
    }

    // CHOISIR OPTION 2 (QUESTION)
    if (BoutonVert == HIGH) {
      lcd.setCursor(0, 2);
      choix_menu = 1;
    }

    // VALIDER CHOIX
    if (BoutonBleu == HIGH) {
      validee = 1;
    }

    // BOUTON GRIS = NE FAIT RIEN
    if (BoutonGris == HIGH) {
    }

  }
  
  // OPTION AFFIRMATIONS
  if (choix_menu == 0) {

    position_menu = 0;

    // AFFICHER MENU AFFIRMATIONS
    imprimer_menu(choix_menu, position_menu);

    // CHOISIR AFFIRMATIONS
    validee = 0;
    retour = 0;
    choix_phrase = 0;
    lcd.setCursor(0, choix_phrase);
    while ((validee == 0) && (retour == 0)) {

      // LIRE
      lire_boutons();
      delay(2000);

      // ALLER EN HAUT
      if (BoutonRouge == HIGH) {


        if (choix_phrase == 0) {
          // on ne fait rien
              if (position_menu == 0){
                
              }
              if (position_menu > 0) {
                position_menu = position_menu - 4;
                imprimer_menu(choix_menu, position_menu);
                choix_phrase = 3;
              }
        }
      
        else {
          choix_phrase--;
        }

        lcd.setCursor(0, choix_phrase);

      }

      // ALLER EN BAS
      if (BoutonVert == HIGH) {

        if (choix_phrase == 3) {

          position_menu = position_menu + 4;
          imprimer_menu(choix_menu, position_menu);
          choix_phrase = 0;

        }
        else {
          int num_phrase = choix_phrase + position_menu;
          if (num_phrase + 1 < nbA) {
            choix_phrase++;
          }

        }

        lcd.setCursor(0, choix_phrase);


      }

      // VALIDER CHOIX
      if (BoutonBleu == HIGH) {
        validee = 1;
        lcd.clear();
      }

      // RETOUR AU MENU PRINCIPAL
      if (BoutonGris == HIGH) {
        validee = 1;
        retour = 1;
      }

    }
  }

 // OPTION QUESTIONS
  if (choix_menu == 1) {

    position_menu = 0;

    // AFFICHER MENU QUESTIONS
    imprimer_menu(choix_menu, position_menu);

    // CHOISIR QUESTIONS
    validee = 0;
    retour = 0;
    choix_phrase = 0;
    lcd.setCursor(0, choix_phrase);
    while ((validee == 0) && (retour == 0)) {

      // LIRE
      lire_boutons();
      delay(200);

      // ALLER EN HAUT
      if (BoutonRouge == HIGH) {


        if (choix_phrase == 0) {
          // on ne fait rien
              if (position_menu == 0){
                
              }
              if (position_menu > 0) {
                position_menu = position_menu - 4;
                imprimer_menu(choix_menu, position_menu);
                choix_phrase = 3;
              }
        }
      
        else {
          choix_phrase--;
        }

        lcd.setCursor(0, choix_phrase);

      }

      // ALLER EN BAS
      if (BoutonVert == HIGH) {

        if (choix_phrase == 3) {

          position_menu = position_menu + 4;
          imprimer_menu(choix_menu, position_menu);
          choix_phrase = 0;

        }
        else {
          int num_phrase = choix_phrase + position_menu;
          if (num_phrase + 1 < nbQ) {
            choix_phrase++;
          }

        }

        lcd.setCursor(0, choix_phrase);


      }

      // VALIDER CHOIX
      if (BoutonBleu == HIGH) {
        validee = 1;
        lcd.clear();
      }

      // RETOUR AU MENU PRINCIPAL
      if (BoutonGris == HIGH) {
        validee = 1;
        retour = 1;
      }

    }
  }




  // MONTRER QUESTION
  if (retour == 0) {
    // AFFICHER SEUELEMTN LA PHRASE SELECTIONNEE
    lcd.clear();
    if (choix_menu == 0) {
      defilerPhrase(menu_a[choix_phrase + position_menu], 1);
    }
    if (choix_menu == 1) {
       defilerPhrase(menu_q[choix_phrase + position_menu], 1);
    }
    delay(5000); // LAISSER AFFICHER X MS
  }

  // RETOUR AU MENU PRINCIPAL
  if (retour == 1) {
    // NE RIEN FAIRE, REVENIR A LA BOUCLE
  }

}

// LIRE LES BOUTONS
void lire_boutons() {
  BoutonRouge = digitalRead(13);
  BoutonVert = digitalRead(12);
  BoutonBleu = digitalRead(11);
  BoutonGris = digitalRead(10);
}

void imprimer_menu(int type_menu, int position) {

    // AFFICHER MENU AFFIRMATIONS
    lcd.clear();
    lcd.noBlink();
    for (int i = 0; i <= 3; i++)
    {
      int numero_phrase = i + position;

      // affirmations
      if (type_menu == 0) {
        if (nbA > numero_phrase) {
          imprimerPhrase(menu_a[numero_phrase], i);
          defilerPhrase(menu_a[numero_phrase], i);
          
        }
      }
      if (type_menu == 1) {
        if (nbQ > numero_phrase) {
          imprimerPhrase(menu_q[numero_phrase], i);
          defilerPhrase(menu_q[numero_phrase], i);
        }
      }

    }
    delay(2000);
    lcd.setCursor(0, 0);
    lcd.blink();
}

// Imprimer le début de la phrase sur la ligne spécifiée
void imprimerPhrase(const char phrase[], int ligne) {
  
  int longueur_phrase = strlen(phrase);
  int substring_length = min(TAILLEECRAN - 1, longueur_phrase);
  
  // Imprimer à partir de case 1 (deuxième case).
  lcd.setCursor(1, ligne);

  char * buff = malloc(TAILLEECRAN * sizeof(char));
  strncpy(buff, phrase, substring_length);
  buff[substring_length] = 0;
  
  lcd.print(buff);
  free(buff);
  //delay(5000);
}

// Fait defiler la phrase sur la ligne spécifiée
void defilerPhrase(const char phrase[], int ligne) {
  
  int longueur_phrase = strlen(phrase);
  if (longueur_phrase <= (TAILLEECRAN - 1)) {
    imprimerPhrase(phrase, ligne);
  }
  else {
    for (int i = 0; i <= (longueur_phrase - (TAILLEECRAN - 1)); ++i) {
      
      int substring_length = min(TAILLEECRAN - 1, longueur_phrase - i);
      lcd.setCursor(1, ligne);
      char * buff = malloc(TAILLEECRAN * sizeof(char));
      strncpy(buff, phrase + i, substring_length);
      buff[substring_length] = 0;
      lcd.print(buff);
      free(buff);
      delay(5000);
    }
  }
}
